-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.UpdateCast = function(SpellID)
	if SpellID==240022 then return end
	cfg.Casting.name, _,_, cfg.Casting.caststart, cfg.Casting.castend, _, cfg.Casting.castId = UnitCastingInfo("player")
	if cfg.Casting.name and cfg.Casting.castId~=0 and cfg.Casting.castId~="0-0-0-0-0-0000000000" then
		cfg.Casting.iscasting=true
		cfg.Casting.caststart=cfg.Casting.caststart / 1e3
		cfg.Casting.castend=cfg.Casting.castend / 1e3
		cfg.Casting.id=SpellID or lib.GetSpellIDbyName(cfg.Casting.name)
		cfg.Casting.spell=cfg.id2spell[cfg.Casting.id] or cfg.Casting.id --"unknown"
		cfg.Casting.cost=lib.GetSpellCost(cfg.Casting.spell)
		if cfg.debugspells then lib.Debug("Casting",cfg.Casting.name,SpellID,cfg.Casting.castId,cfg.Casting.castend) end
		return true
	else
		cfg.Casting.iscasting=false
		cfg.Casting.cost=0
		cfg.Casting.id=false
		cfg.Casting.castId=false
		cfg.Casting.spell=false
		cfg.Casting.castend=0
		cfg.Casting.caststart=0
		if cfg.debugspells then lib.Debug("Not casting",cfg.Casting.name,SpellID,cfg.Casting.castId) end
		return false
	end
end

lib.UpdateCastStop = function(SpellID)
	cfg.Casting.iscasting=false
	cfg.Casting.cost=0
	cfg.Casting.id=false
	cfg.Casting.castId=false
	cfg.Casting.spell=false
	cfg.Casting.castend=0
	cfg.Casting.caststart=0
	if cfg.debugspells then lib.Debug("Not casting",cfg.Casting.name,SpellID,cfg.Casting.castId) end
	return false
end

lib.UpdateChannel = function(SpellID,event)
	event=event or "unknown"
	cfg.Channeling.name, _, _, cfg.Channeling.startTime, cfg.Channeling.endTime = UnitChannelInfo("player")
	if cfg.Channeling.name then
		cfg.Channeling.ischanneling=true
		cfg.Channeling.startTime=cfg.Channeling.startTime / 1e3
		cfg.Channeling.endTime=cfg.Channeling.endTime / 1e3
		cfg.Channeling.id=SpellID or lib.GetSpellIDbyName(cfg.Channeling.name)
		cfg.Channeling.spell=cfg.id2spell[cfg.Channeling.id] or "unknown"
		cfg.Channeling.cost=lib.GetSpellCost(cfg.Channeling.spell)
		if cfg.spells[cfg.Channeling.spell] then
			cfg.spells[cfg.Channeling.spell].channel=endTime
			--print("Channel "..cfg.Channeling.name)
			if cfg.spells[cfg.Channeling.spell].nointerupt then
				cfg.Channeling.nointerupt=true
			end
		end
		--if event~="SPELL_DATA_LOAD_RESULT" then 
		--print("Added channeling on "..event) --end
		return true
	else
		--if event~="SPELL_DATA_LOAD_RESULT" then 
		--print("Reset channeling on "..event) --end
		if cfg.spells[cfg.Channeling.spell] then
			cfg.spells[cfg.Channeling.spell].channel=0
		end
		cfg.Channeling.nointerupt=false
		cfg.Channeling.ischanneling=false
		cfg.Channeling.cost=0
		cfg.Channeling.id=false
		cfg.Channeling.spell=false
		cfg.Channeling.startTime=0
		cfg.Channeling.endTime=0
		return false
	end
end



lib.IsCasting = function(spell)
	if cfg.Casting.iscasting then --and cfg.Casting.castend>GetTime()
		if spell then
			if cfg.Casting.spell==spell then
				return true
			else
				return false
			end
		else
			return true
		end
	else
		return false
	end
end

lib.IsChanneling = function(spell)
	if cfg.Channeling.ischanneling then --and cfg.Channeling.endTime>GetTime()
		if spell then
			if cfg.Channeling.spell==spell then
				return true
			else
				return false
			end
		else
			return true
		end
	else
		return false
	end
end

lib.IsChannelingNoInterrupt = function()
	if cfg.Channeling.ischanneling and cfg.Channeling.nointerupt then --and cfg.Channeling.endTime>GetTime()
		return true
	else
		return false
	end
end

lib.GetCastingSpell=function()
	if lib.IsCasting() then
		return cfg.Casting.spell
	end
	return nil
end

lib.GetCastingSpellCost=function()
	if lib.IsCasting() then
		return cfg.Casting.cost
	end
	return 0
end

lib.SpellCastingLeft=function(spell)
	if (spell) then
		if  (cfg.Casting.spell==spell) then 
			return math.max(0,(cfg.Casting.castend-GetTime()),cfg.Channeling.nointerupt and (cfg.Channeling.endTime-GetTime()) or 0)
		else
			return 0
		end
	else
		return math.max(0,(cfg.Casting.castend-GetTime()),cfg.Channeling.nointerupt and (cfg.Channeling.endTime-GetTime()) or 0)
	end
	return 0
--[[	if lib.IsCasting() then
		if (not spell) or (spell and cfg.spells[spell] and cfg.spells[spell].name==cfg.Casting.name) then
			return math.max(0,(cfg.Casting.castend-GetTime()),lib.IsChannelingNoInterrupt() and (cfg.Channeling.endTime-GetTime()) or 0)
		end
	end
	return 0]]
end

lib.SpellChannelingLeft=function(spell)
	if lib.IsChanneling() and cfg.Channeling.spell==spell then
		return math.max(0,cfg.Channeling.endTime-GetTime())
	end
	return 0

--[[	if lib.IsCasting() then
		if (not spell) or (spell and cfg.spells[spell] and cfg.spells[spell].name==cfg.Casting.name) then
			return math.max(0,(cfg.Casting.castend-GetTime()),lib.IsChannelingNoInterrupt() and (cfg.Channeling.endTime-GetTime()) or 0)
		end
	end
	return 0]]
end

lib.SpellCasting=function(spell)
	if lib.IsCasting() or lib.IsChanneling() then
		if (not spell) or (spell and cfg.spells[spell] and (cfg.spells[spell].id==cfg.Casting.id or cfg.spells[spell].id==cfg.Channeling.id)) then
			return true
		else
			return false
		end
	end
	return false
end

lib.SpellCastingId=function(ids)
	if lib.IsCasting() or lib.IsChanneling() then
		for index,id in ipairs(ids) do
			if cfg.Casting.id==id or cfg.Channeling.id==id then return true end
		end
	end
	return false
end

cfg.lastspell_name=""
cfg.lastspell=0
cfg.lastspell2=0

lib.SaveCast = function(SpellID,spellname)
	--print(SpellID.." - "..spellname)
	if not SpellID then return end
	cfg.spellcast[SpellID]=GetTime()
	if cfg.NoSaveSpell and cfg.NoSaveSpell[SpellID] then return end
	if cfg.SaveSpell and not cfg.SaveSpell[SpellID] then return end
	if cfg.debug_lastcast then
		print(SpellID.." - "..spellname)
	end
	cfg.lastspell2=cfg.lastspell
	cfg.lastspell=SpellID
	cfg.lastspell_name=spellname
	cfg.lastspell_time=GetTime()
end

lib.NoSaveSpell = function(SpellID)
	if not cfg.MonitorSpells then return end
	if type(SpellID) == "string" and cfg.spells[SpellID] then
		SpellID=cfg.spells[SpellID].id
	end
	cfg.NoSaveSpell=cfg.NoSaveSpell or {}
	cfg.NoSaveSpell[SpellID]=true
	if cfg.SaveSpell then
		cfg.SaveSpell[SpellID]=nil
	end
end

lib.SaveSpell = function(SpellID)
	if not cfg.MonitorSpells then return end
	if type(SpellID) == "string" and cfg.spells[SpellID] then
		SpellID=cfg.spells[SpellID].id
	end
	cfg.SaveSpell=cfg.SaveSpell or {}
	cfg.SaveSpell[SpellID]=true
	if cfg.NoSaveSpell then
		cfg.NoSaveSpell[SpellID]=nil
	end
end

lib.IsLastSpell = function(spell)
	if cfg.lastspell then
		if type(spell)=="table" then
			for _,ispell in ipairs(spell) do
				if cfg.lastspell==ispell or (cfg.spells[ispell] and cfg.id2spell[cfg.lastspell]==ispell) then
					return true
				end
			end
		else
			if cfg.lastspell==spell or (cfg.spells[spell] and cfg.id2spell[cfg.lastspell]==spell) then
				return true
			end
		end

	end
	return false
end

lib.GetLastSpell = function (spells)
	for _,cspell in ipairs(spells) do
		if cfg.spells[cspell] and cfg.spellcast[cfg.spells[cspell].id] then
			if GetTime()<(cfg.spellcast[cfg.spells[cspell].id]-cfg.spells[cspell].castingTime+1) then
				return true
			end
		end
	end
	return nil
end

lib.GetSpellLastCast=function(spell)
	if cfg.spells[spell] and cfg.spellcast[cfg.spells[spell].id] then
		return (GetTime()-cfg.spellcast[cfg.spells[spell].id])
	end
	return 9999
end

lib.SetInterrupt = function(spell,ids,addbuff,cost_real,nointerupt,nousecheck,noplayercheck)
	lib.AddSpell(spell,ids,addbuff,cost_real,nointerupt,nousecheck,noplayercheck)
	if cfg.spells[spell] then
		Heddmain.Interrupt.spell=spell
		Heddmain.Interrupt.SpellID=cfg.spells[spell].id
		Heddmain.Interrupt.icon:SetTexture(cfg.spells[spell].icon)
		Heddmain.Interrupt:Show()
		lib.SetSpellFunction(spell,"OnUpdate",lib.OnUpdateInterrupt)
		cfg.Interrupt.spell=spell
		cfg.case[spell] = function()
			if cfg.Interrupt.spell and lib.IsTargetCastingInterruptible() and lib.GetTargetCastingLeft()>lib.GetSpellCD(spell) then
				return lib.SimpleCDCheck(spell)
			end
			return nil
		end
	end
end

lib.OnUpdateInterrupt=function()
	if cfg.spells[cfg.Interrupt.spell].cd>0 then
		CooldownFrame_SetTimer(Heddmain.Interrupt.cd,cfg.spells[cfg.Interrupt.spell].start, cfg.spells[cfg.Interrupt.spell].cd,1)
		UIFrameFlashStop(Heddmain.Interrupt.bd)
	else
		if cfg.Interrupt.Interruptible then
			UIFrameFlash(Heddmain.Interrupt.bd,cfg.Interrupt.flash,cfg.Interrupt.flash,-1)
		end
		Heddmain.Interrupt.cd:Hide()
	end
end

lib.IsTargetCastingInterruptible = function()
	if cfg.Interrupt.Interruptible then
		return true
	else
		return false
	end
end

lib.GetTargetCastingLeft = function()
	if cfg.Interrupt.Interruptible then
		return math.max(0,cfg.Interrupt.endTime-GetTime())
	else
		return 0
	end
end

local interrupt_old={}
--[[lib.UpdateTargetCast = function(SpellID)
	SpellID=SpellID or false
	hedlib.shallowCopy(cfg.Interrupt,interrupt_old)
	cfg.Interrupt.name, _, _, cfg.Interrupt.caststart, cfg.Interrupt.castend, _, cfg.Interrupt.castId, cfg.Interrupt.notInterruptible = UnitCastingInfo("target")
	if cfg.Interrupt.name then
		cfg.Interrupt.iscasting=true
		cfg.Interrupt.caststart=cfg.Interrupt.caststart / 1e3
		cfg.Interrupt.castend=cfg.Interrupt.castend / 1e3
		cfg.Interrupt.id=SpellID
	else
		cfg.Interrupt.iscasting=false
		cfg.Interrupt.id=false
		cfg.Interrupt.castId=false
	end
	if not hedlib.ArrayNotChanged(cfg.Interrupt,interrupt_old) then
		cfg.Update=true
	end
	if not cfg.Interrupt.iscasting then
		lib.UpdateTargetChannel(SpellID)
	end
end]]

lib.UpdateTargetCasting = function(event, unit)
	event=event or "Unknown"
	unit=unit or "target"
	if unit=="target" then
		hedlib.shallowCopy(cfg.Interrupt,interrupt_old)
		cfg.Interrupt.name, cfg.Interrupt.text, cfg.Interrupt.texture, cfg.Interrupt.startTime, cfg.Interrupt.endTime, _, cfg.Interrupt.castID, cfg.Interrupt.notInterruptible, cfg.Interrupt.spellID = UnitCastingInfo(unit)
		event = 'UNIT_SPELLCAST_START'
		if(not cfg.Interrupt.name) then
			cfg.Interrupt.name, cfg.Interrupt.text, cfg.Interrupt.texture, cfg.Interrupt.startTime, cfg.Interrupt.endTime, _, cfg.Interrupt.notInterruptible, cfg.Interrupt.spellID = UnitChannelInfo(unit)
			event = 'UNIT_SPELLCAST_CHANNEL_START'
		end
		if cfg.Interrupt.name then
			cfg.Interrupt.endTime = cfg.Interrupt.endTime or 0
			cfg.Interrupt.endTime = cfg.Interrupt.endTime / 1000
			cfg.Interrupt.startTime = cfg.Interrupt.startTime or 0
			cfg.Interrupt.startTime = cfg.Interrupt.startTime / 1000
			cfg.Interrupt.casting = event == 'UNIT_SPELLCAST_START'
			cfg.Interrupt.channeling = event == 'UNIT_SPELLCAST_CHANNEL_START'
			local targetcast_max=cfg.Interrupt.endTime-cfg.Interrupt.startTime
			if cfg.Interrupt.max<targetcast_max then cfg.Interrupt.max=targetcast_max end
			cfg.Interrupt.Interruptible = not cfg.Interrupt.notInterruptible
		else
			cfg.Interrupt.casting = nil
			cfg.Interrupt.channeling = nil
			cfg.Interrupt.max=0
			cfg.Interrupt.notInterruptible=true
			cfg.Interrupt.Interruptible=false
		end
		local notchanged,key=hedlib.ArrayNotChanged(cfg.Interrupt,interrupt_old)
		if not notchanged then
			--print(key.." changed")
			if cfg.Interrupt.casting or cfg.Interrupt.channeling then
				Heddmain.tagetcast.icon:SetTexture(cfg.Interrupt.texture)
				Heddmain.tagetcast:Show()
				CooldownFrame_SetTimer(Heddmain.tagetcast.cd,cfg.Interrupt.startTime, cfg.Interrupt.max,1)
				if (cfg.Interrupt.Interruptible) then
					if cfg.spells[cfg.Interrupt.spell].cd<cfg.gcd then
						UIFrameFlash(Heddmain.Interrupt.bd,cfg.Interrupt.flash,cfg.Interrupt.flash,-1)
					end
					Heddmain.tagetcast.bd:Hide()
					Heddmain.tagetcast.shine:Show()
				else
					UIFrameFlashStop(Heddmain.Interrupt.bd)
					Heddmain.tagetcast.bd:Show()
					Heddmain.tagetcast.shine:Hide()
				end
			else
				UIFrameFlashStop(Heddmain.Interrupt.bd)
				Heddmain.tagetcast:Hide()
			end
			cfg.Update=true
		end
	end
end

--[[lib.UpdateTargetChannel = function(SpellID)

	SpellID=SpellID or false
	hedlib.shallowCopy(cfg.Interrupt,interrupt_old)
	cfg.Interrupt.name, _, _, cfg.Interrupt.caststart, cfg.Interrupt.castend, _, cfg.Interrupt.notInterruptible = UnitChannelInfo("target")
	if cfg.Interrupt.name then
		--print(tostring(cfg.Interrupt.notInterruptible))
		cfg.Interrupt.iscasting=true
		cfg.Interrupt.caststart=cfg.Interrupt.caststart / 1e3
		cfg.Interrupt.castend=cfg.Interrupt.castend / 1e3
		cfg.Interrupt.id=SpellID
	else
		cfg.Interrupt.iscasting=false
		cfg.Interrupt.id=false
		cfg.Interrupt.castId=false
	end
	if not hedlib.ArrayNotChanged(cfg.Interrupt,interrupt_old) then
		cfg.Update=true
	end
end]]
